MantisBT

View Issue Details Jump to Notes ] Issue History ] Print ]
IDProjectCategoryView StatusDate SubmittedLast Update
0001266VCMIMechanics - Battlespublic2013-05-20 12:502017-08-09 23:06
ReporterIvan 
Assigned To 
PrioritynormalSeverityminorReproducibilityalways
StatusnewResolutionopen 
PlatformOSOS Version
Product Version 
Target VersionFixed in Version 
Summary0001266: Battle-wide bonuses of upgrades do not stack with downgrades.
DescriptionCheck screenshot. My army consists from 4 stacks:
2 stacks of bone dragons
2 stacks of ghost dragons

H3 behaviour here is -1 morale no matter how many stacks hero army has (usually compensated by same alignment bonus).
This means that:
[FIXED] 1) No bonuses stacking from _same_ creatures (for some reason works correctly for Ghost D. but not for Bone D.)
2) Battle-wide bonuses of upgrades do not stack with downgrades. Same goes to Angel + Archangel and Devils + Archdevils bonuses.
TagsNo tags attached.
Attached Filespng file icon stackydragons.png [^] (979,845 bytes) 2013-05-20 12:50

- Relationships
parent of 0002517new Bonuses: angels and archangels give separate +1 morale 
parent of 0002608closedAVS Double morale bonus from angels and archangels 
Not all the children of this issue are yet resolved or closed.

-  Notes
(0003544)
Tow (developer)
2013-05-20 17:44

As for the Bone Dragon: isn't this yet another duplicated bonus? (both in ZCRTRAIT and in .JSON)

***

Tough one.
The -1 morale modifier nneds to be in a single bonus system node that is parent both to Bone Dragons and Ghost Dragons.

I'm not sure how this should be done. I think about some custom step in creature handler after loading creatures that goes over sets of creatures that are in upgrade/downgrade transitive relation and:
* checks if all creatures in the group share the same bonus(es). For efficiency this can be limited to bonuses with propagators / ONLY_ENEMY_ARMY range (that range should be propgator actually…)
* if they do, create a new bonus node, put shared bonuses in there. Attach all creatures to that node.

(Plus tweaking the ONLY_ENEMY_ARMY workaround but that won't be hard.)
(0003554)
Ivan (developer)
2013-05-25 11:02

Bone dragons should be OK now. Editing report a bit to match current situation.
(0007216)
Anubis (reporter)
2017-08-06 11:38

Can I add some information about current behaviour?
Right now the bonuses from 2 different grades of units (Angels/Archangels, Devils/Archdevils, Bone/Ghost Dragons) do stack, so +2 to Morale (or -2 to Luck/Morale respectively) is applied. That's not correct.

However, this is different for Pegasi/Magi (neither bonuses/debuffs from 2 different grades nor different unit stacks work), so their interactions (spell cost decrease/increase) are correct.
(0007221)
AVS (administrator)
2017-08-09 22:51

@Anubis, bonus calculation for Pegasi/Magi is hardcoded as special case (for other reason) that`s why they are not affected by this bug.

- Issue History
Date Modified Username Field Change
2013-05-20 12:50 Ivan New Issue
2013-05-20 12:50 Ivan File Added: stackydragons.png
2013-05-20 13:03 Ivan Description Updated View Revisions
2013-05-20 17:44 Tow Note Added: 0003544
2013-05-25 11:02 Ivan Note Added: 0003554
2013-05-25 11:03 Ivan Summary Bonuses from different groups of same creatures stack => Battle-wide bonuses of upgrades do not stack with downgrades.
2013-05-25 11:03 Ivan Description Updated View Revisions
2016-09-25 19:37 Warmonger Relationship added parent of 0002517
2017-08-06 11:38 Anubis Note Added: 0007216
2017-08-09 22:51 AVS Note Added: 0007221
2017-08-09 23:06 AVS Relationship added parent of 0002608

Site | Forums | Wiki | Slack | GitHub


Copyright © 2000 - 2017 MantisBT Team
Hosting provided by DigitalOcean